from PyQt4 import QtCore, QtGui

class Keyboard(QtGui.QX11EmbedContainer):
  def __init__(self, parent):
    QtGui.QWidget.__init__(self, parent)

    self.process=QtCore.QProcess(self)
    if self.process:
      self.process.start("matchbox-keyboard --xid")
      if self.process.waitForStarted():
        self.process.waitForReadyRead()
        id=int(self.process.readLine())
        self.embedClient(id)
      else:
        self.process=None
    self.setSizePolicy(QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Maximum)

  def closeEvent(self, e):
    if self.process:
      self.process.terminate()
      self.process.waitForFinished(3000)
      self.process.kill()
    e.accept()
